package com.gct.tools.etlcamelhuge.entity;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.gct.tools.etlcamelhuge.MQ.MessageBody;
import lombok.AllArgsConstructor;
import lombok.Data;

@Data
@AllArgsConstructor
public class DiagnoseMsg implements MessageBody {

    private String wellId;
    private String wellName;
    private String orgId;

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    private String prodDate;
    private String sgt;
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    private String rcvDate;
    private double s;
    private double n;




    @Override
    public String toJsonBody() {
        return JSONObject.toJSONString(this);
    }
}
