package com.gct.tools.etlcamelhuge;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gct.tools.etlcamelhuge.entity.GTBody;
import com.gct.tools.etlcamelhuge.routeconfig.CamelJDBCConfiguration;
import io.micrometer.core.instrument.util.IOUtils;
import lombok.Data;
import org.apache.camel.AggregationStrategy;
import org.apache.camel.CamelContext;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.http.common.HttpMessage;
import org.apache.camel.impl.DefaultCamelContext;
import org.apache.camel.model.ModelCamelContext;
import org.junit.jupiter.api.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.annotation.Bean;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Array;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import static org.junit.Assert.assertEquals;

@RunWith(SpringRunner.class)
@SpringBootTest
class EtlCamelHugeApplicationTests {

   /* @Autowired
    RouteBuilder routeBuilder;*/

    @Test
    public void contextLoads() {
    }

    @Test
    public void test1() {
        Double[] num = {8.0, 6.0, 3.0, 2.0};
        List<Double> lis = new java.util.ArrayList<>(Arrays.asList(num));
        lis.add(0.9);
        System.out.println("1___________" + lis);
        List<Double> lis1 = new java.util.ArrayList<Double>(Arrays.asList(lis.subList(lis.size() / 2 - 1, lis.size()).toArray(new Double[]{})));
        List<Double> lis2 = new java.util.ArrayList<Double>(Arrays.asList(lis.subList(0, lis.size() / 2 - 1).toArray(new Double[]{})));

        double x = lis.get(0).doubleValue();
        System.out.println("2___________" + lis1);

        lis.add(lis.get(0));
        System.out.println("3___________" + lis);
        lis1.add(lis.get(0));
        lis2.add(9.8);
        System.out.println("4___________" + lis1);
        System.out.println("___________" + lis2);
    }

    @Test
    public void test2() {
        List<Double[]> p1 = new ArrayList<>();
        Double[] num0 = {8.0, 6.0};
        Double[] num1 = {0.0, 5.0};
        Double[] num2 = {6.0, 7.0};

        p1.add(num0);
        p1.add(num1);
        p1.add(num2);
        System.out.println(p1.toArray(new Double[p1.size()][]));
        System.out.println("p1====================" + p1);

        Double[][] a = new Double[][]{};
        System.out.println(a.getClass());
        List<Double[]> p_p1 = p1.subList(0, p1.size() / 2);
        System.out.println(p_p1);

        p_p1.add(num0);
        System.out.println(p_p1);
        System.out.println("p1====================" + p1);
        if (false) {
            List<Double> lis = new java.util.ArrayList<>(Arrays.asList(num0));
            lis.add(0.9);
            System.out.println("1___________" + lis);
            List<Double> lis1 = new java.util.ArrayList<Double>(Arrays.asList(lis.subList(lis.size() / 2 - 1, lis.size()).toArray(new Double[]{})));
            List<Double> lis2 = new java.util.ArrayList<Double>(Arrays.asList(lis.subList(0, lis.size() / 2 - 1).toArray(new Double[]{})));

            double x = lis.get(0).doubleValue();
            System.out.println("2___________" + lis1);

            lis.add(lis.get(0));
            System.out.println("3___________" + lis);
            lis1.add(lis.get(0));
            lis2.add(9.8);
            System.out.println("4___________" + lis1);
            System.out.println("___________" + lis2);
        }
    }

    @Data
    class te {
        private double m;

        //        @Cons
        public te(double m) {
            this.m = m;
        }
    }

    @Test
    public void test3() {

        te s = new te(0.9);
        System.out.println(s);
        System.out.println(s.getClass());
        try {
            Class<?> clazz = Class.forName("com.gct.tools.etlcamelhuge.EtlCamelHugeApplicationTests$te");
            te t = (te) clazz.getConstructor(double.class).newInstance(9.0);

            System.out.println(t);

        } catch (NoSuchMethodException e) {
            e.printStackTrace();
        } catch (InvocationTargetException e) {
            e.printStackTrace();
        } catch (InstantiationException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }

        ArrayList<Double> a1 = new ArrayList<Double>();

        a1.add(0.9);
        a1.add(0.8);
        Double[] objects = a1.toArray(new Double[]{});

        for (int i = 0; i < objects.length; i++) {
            System.out.println(objects[i]);
        }

    }

    private <T> T[][] transfer(List<List<T>> source, Class<T> tClass) {

        List<T[]> l1 = new ArrayList<>();
        for (List<T> ts : source) {
            T[] t = (T[]) Array.newInstance(tClass, ts.size());
            for (int i = 0; i < ts.size(); i++) {
                t[i] = ts.get(i);
            }

            l1.add(t);
        }
        T[][] ts = l1.toArray((T[][]) Array.newInstance(tClass, source.size()));
        return ts;

    }

    @Autowired
    CamelJDBCConfiguration camelJDBCConfiguration;
    @Test
    public void test10() {

    }

    public static void main(String args[]) throws Exception {
        CamelContext context = new DefaultCamelContext();
        //new ClassPathXmlApplicationContext("jetty/camel.xml");
        context.addRoutes(new RouteBuilder() {
            @Override
            public void configure() {
                JSONObject body = new JSONObject();
                body.put("userno", "zdcycgtlyxt"); // 分配的系统用户账号
                body.put("password", "Zdcycgtlyxt");
                from("timer:mytimer?repeatCount=1")
                        .setBody(simple(body.toJSONString()))
                        .removeHeaders("CamelHttp*")
                        .to("http://11.71.3.110:30010/dibs/0/service/token")
                        .log("${body}:");
            }
        });
        context.start();
        boolean loop = true;
        while (loop) {
            Thread.sleep(25000);
        }
        context.stop();
    }


}
