package com.gct.tools.etlcamelhuge.MQ;

import org.apache.rocketmq.client.exception.MQClientException;
import org.apache.rocketmq.client.producer.DefaultMQProducer;

/**
 * class name: DiagnoseDelayedMessageProducer
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/6/24 下午7:41
 */
public class DiagnoseDelayedMessageProducer implements MessageProducer {
    DefaultMQProducer producer;

    @Override
    public void destroy() {
        producer.shutdown();
    }

    @Override
    public void init() {
        try {
            producer.start();
        } catch (MQClientException e) {
            System.out.println("Error");
        }
    }

    //@Scheduled(zone = "****")
    public void task() {
        /**
         * TODO:
         * 完善延迟重发策略以及统一补偿策略
         * 间隔一段时间将logfile中的统一生产到mq中
         * 默认7天2G（循环擦除1小时）限制，理论上本地空间无限保留时间无限
         */
        //Executors.newScheduledThreadPool(1).schedule()
        //Quartz
    }
}
